/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.test.sharedtimer;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.TimerTask;
import java.util.logging.ConsoleHandler;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author banton
 */
public class SharedTimerTestServlet 
    extends HttpServlet
{


    static final Logger LOGGER  = Logger.getLogger(SharedTimerTestServlet.class.getName());

    CSharedTimer timer;
    int count = 0;

    //
    // Only this methods are interested by we
    //
    /**
     * Init servlet and starts SHARED TERRACOTTA OBJECT
     * @throws ServletException
     */
    @Override
    public void init()
        throws ServletException
    {
        super.init();
    ServletContext servletContext = getServletContext();
    String  value=servletContext.getInitParameter("log-level");
        if (value!=null && value.length() > 0)
            {
            Level logLevel = Level.parse(value);

            if (logLevel!=null)
                {
                Logger logger = Logger.getLogger(getClass().getPackage().getName());
                logger.setLevel(logLevel);

                Handler handler = new ConsoleHandler();
                handler.setFormatter(new SimpleFormatter());
                handler.setLevel(logLevel);
                logger.addHandler(handler);
                logger.setUseParentHandlers(false);
                }
            }


    TimerTask timerTask =
        new TimerTask()
        {
            @Override
            public void run()
            {
                handleTimeout();
            }
        };

        
        // Creates timer with cluster timeout 30 sec
        timer = new CSharedTimer("Shared-Timer", timerTask, 30000);
        timer.start();
    }


    @Override
    public void destroy()
    {
        timer.setStopped();
        super.destroy();
    }


    protected void handleTimeout()
    {
        LOGGER.info("Handle timeout "+(++count));
    }



    // ================================================================================================================
    // =========================================   SOME STUFF =========================================================
    // ================================================================================================================
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();

    ServletContext servletContext = this.getServletContext();
    RequestDispatcher requestDispatcher = servletContext.getRequestDispatcher("/index.jsp");


        if (requestDispatcher!=null)
            {
            request.setAttribute("count", new Integer(count) );
            requestDispatcher.forward(request, response);
            }
        else
            try {
                /* TODO output your page here */
                out.println("<html>");
                out.println("<head>");
                out.println("<title>Servlet SharedTimerTestServlet</title>");
                out.println("</head>");
                out.println("<body>");
                out.println("<h1>Servlet SharedTimerTestServlet at " + request.getContextPath () + "</h1>");
                out.println("<h1>Handled timeout " + count + "times</h1>");
                out.println("</body>");
                out.println("</html>");
                }
            finally
                {
                out.close();
                }
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
